package cn.ey.biz.module.system.service.i18n;

import cn.ey.biz.common.pojo.PageResult;
import cn.ey.biz.module.system.api.i18n.dto.I18nDTO;
import cn.ey.biz.module.system.controller.admin.i18n.vo.*;
import cn.ey.biz.module.system.dal.dataobject.i18n.I18nDO;

import javax.validation.Valid;
import java.util.Collection;
import java.util.List;

/**
 * 多语言 Service 接口
 */
public interface I18nService {

    /**
     * 初始化多语言的本地缓存
     */
    void initLocalCache();

    /**
     * 获取语言
     *
     * @param key
     * @param lang
     * @param type
     * @return
     */
    String getLabel(String key, String lang, String type);

    /**
     * 从数据库中获取语言
     *
     * @param key
     * @param lang
     * @param type
     * @return
     */
    String getLabelFromDB(String key, String lang, String type);

    /**
     * 创建多语言(多条)
     *
     * @param createReqVO 创建信息
     * @return
     */
    void createI18nList(@Valid List<I18nCreateReqVO> createReqVO);

    /**
     * 导入多语言信息
     *
     * @param i18ns 多语言信息
     */
    void importI18nList(@Valid List<I18nDTO> i18ns);

    /**
     * 创建多语言
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createI18n(@Valid I18nCreateReqVO createReqVO);

    /**
     * 更新多语言
     *
     * @param updateReqVO 更新信息
     */
    void updateI18n(@Valid I18nUpdateReqVO updateReqVO);

    /**
     * 删除多语言
     *
     * @param
     */
    void deleteI18n(Long id);

    /**
     * 获得多语言
     *
     * @param id 编号
     * @return 多语言
     */
    I18nDO getI18n(Long id);

    /**
     * 获得多语言列表
     *
     * @param ids 编号
     * @return 多语言列表
     */
    List<I18nDO> getI18nList(Collection<Long> ids);

    /**
     * 获得多语言分页
     *
     * @param pageReqVO 分页查询
     * @return 多语言分页
     */
    PageResult<I18nRespVO> getI18nPage(I18nPageReqVO pageReqVO);

    /**
     * 获得多语言列表, 用于 Excel 导出
     *
     * @param exportReqVO 查询条件
     * @return 多语言列表
     */
    List<I18nDO> getI18nList(I18nExportReqVO exportReqVO);

    void deleteI18nByKey(String key);

    List<I18nDO> getI18nByApp(String acceptLanguage, String app);

    /**
     * 导入label类型
     *
     */
    void importI18nListLabel(@Valid List<I18nExcelImportVO> i18ns);
}
